{
  open Parser
  exception Error of string
}

rule token = parse
     | [' ' '\t']     { token lexbuf }
     | '\n'           { EOL }
     | ['0'-'9']+ as i     { INT (int_of_string i) }
     | '+'     { PLUS }
     | '*'     { TIMES }
     | '('     { LPARA }
     | ')'     { RPARA }
     | _       { raise (Error (Lexing.lexeme lexbuf)) }