{
  open Parser
  exception Error of string
}

rule token = parse
     | [' ' '\t']     { token lexbuf }
     | '\n'           { EOL }
     | ['0'-'9']+ as i     { INT (int_of_string i) }
     | '@'     { AT }
     | '$'     { DOLLAR }
     | '#'     { SHARP }
     | '&'     { AMP }
     | '('     {PARG}
     | ')'     {PARD}
     | _       { raise (Error (Lexing.lexeme lexbuf)) }